/**
 * This component represents the current viewbox of the SVG canvas and is responsible for zooming and moving the current view.
 *
 * @author baltes
 * @see SvgCanvas.js
 *
 *//*

var SvgViewBox = (function (util) {

    var SvgViewBox = function(args) {
        if (!args.svgRoot) {
            throw new ReferenceError(APPLICATION_NAME + ": SVG root is " + args.svgRoot + ".")
        }

        //region Private members
        var that,
            svgRoot,
            svgImage,
            x,
            y,
            width,
            height,
            initialX,
            initialY,
            initialWidth,
            initialHeight,
            offsetLeft,
            offsetTop,
            zoomLevel;

        that = this;
        svgRoot = args.svgRoot;
        svgImage = $(svgRoot).find('g:first > image:first').get(0);
        initialWidth= parseFloat($(svgImage).attr('width'));
        initialHeight = parseFloat($(svgImage).attr('height'));
        zoomLevel = 0;
        offsetLeft = 0;
        offsetTop = 0;
        //endregion

        //region Constants
        Object.defineProperties(this,
        {
            "MOVEMENT_STEP": {
                value: 0.1
            },
            "ZOOMING_STEP": {
                value: 1.2
            },
            "PRECISION": {
                value: 6
            },
            "x": {
                get: function() {
                    return x;
                }
            },
            "y": {
                get: function() {
                    return y;
                }
            },
            "width": {
                get: function() {
                    return width;
                }
            },
            "height": {
                get: function() {
                    return height;
                }
            }
        });
        //endregion

        //region Private methods
        function set(newMinX, newMinY, newWidth, newHeight) {
            x = newMinX.roundFloat(that.PRECISION);
            y = newMinY.roundFloat(that.PRECISION);
            width = newWidth.roundFloat(that.PRECISION);
            height = newHeight.roundFloat(that.PRECISION);

            $(svgRoot).get(0).setAttributeNS(null, "viewBox", x + " " + y + " " + width + " " + height);
        }

        function center(canvasWidth, canvasHeight) {
            var scaleFactor = util.getElementToScreenScaleFactor(canvasWidth, canvasHeight, initialWidth, initialHeight);

            var pixelWidth = initialWidth * scaleFactor;
            var pixelHeight = initialHeight * scaleFactor;
            var pixelLeft = (canvasWidth - pixelWidth)/2;
            var pixelTop = (canvasHeight - pixelHeight)/2;
            var newX = -pixelLeft/scaleFactor;
            var newY = -pixelTop/scaleFactor;

            initialX = newX;
            initialY = newY;
            zoomLevel = 0;
            offsetLeft = 0;
            offsetTop = 0;

            set(
                newX,
                newY,
                initialWidth,
                initialHeight
            );
        }

        function zoom() {
            var zoomFactor = Math.pow(that.ZOOMING_STEP, Math.abs(zoomLevel));

            if (zoomLevel === 0) {
                scale(1);
            } else if (zoomLevel > 0) {
                scale(1/zoomFactor);
            } else if (zoomLevel < 0) {
                scale(zoomFactor);
            }
        }

        function scale(scaleFactor) {
            var newWidth = initialWidth*scaleFactor;
            var newHeight = initialHeight*scaleFactor;
            var newX = initialX*scaleFactor + offsetLeft - (newWidth-initialWidth)/2;
            var newY = initialY*scaleFactor + offsetTop - (newHeight-initialHeight)/2;

            set(
                newX,
                newY,
                newWidth,
                newHeight
            );
        }

        function zoomIn() {
            zoomLevel += 1;
            zoom();
        }

        function zoomOut() {
            zoomLevel -= 1;
            zoom();
        }

        function moveLeft() {
            offsetLeft -= that.MOVEMENT_STEP;

            set(
                x - that.MOVEMENT_STEP,
                y,
                width,
                height
            );
        }

        function moveRight() {
            offsetLeft += that.MOVEMENT_STEP;

            set(
                x +  that.MOVEMENT_STEP,
                y,
                width,
                height
            );
        }

        function moveUp() {
            offsetTop -= that.MOVEMENT_STEP;

            set(
                x,
                y - that.MOVEMENT_STEP,
                width,
                height
            );
        }

        function moveDown() {
            offsetTop += that.MOVEMENT_STEP;

            set(
                x,
                y + that.MOVEMENT_STEP,
                width,
                height
            );
        }
        //endregion

        //region Privileged methods
        this.center = center;
        this.zoomIn = zoomIn;
        this.zoomOut = zoomOut;
        this.moveUp = moveUp;
        this.moveDown = moveDown;
        this.moveLeft = moveLeft;
        this.moveRight = moveRight;
        //endregion
    };

    return SvgViewBox;

})(util);*/
