/**
 * This file is used to define global variables and to augment existing objects / prototypes.
 *
 * @author baltes
 *
 */

/* constants */
var APPLICATION_NAME = "SketchLink";
//var LOGGING = false; // disable logging on startup
var WEBSOCKET_URL = "ws://136.199.55.236:8080/websocket";

/* object to store references to every popup */
var popups = {};
var websocket;

/* changelog for upload */
var changelog = {};

/* shorthand for adding public method to object */
Function.prototype.publicMethod = function (methodName, func) {
    if (this.prototype[methodName]) {
        throw new TypeError(APPLICATION_NAME + ": Method " + methodName + " already exists.");
    } else {
        this.prototype[methodName] = func;
    }
    return this;
};

/* round float to a given precision */
Number.prototype.roundFloat = function(precision) {
    var factor = Math.pow(10, precision);
    return Math.round(this * factor) / factor;
};

/* extend String protoype */
String.prototype.startsWith = function(prefix) {
    return this.indexOf(prefix, 0) !== -1;
};

String.prototype.endsWith = function(suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
};

/* extend jQuery with an exists function */
$.fn.exists = function () {
    return (this.length !== 0);
};