import sqlite3
import sketchlink


def query_db(query, args=(), one=False):
    db = sqlite3.connect(sketchlink.DB_PATH)
    db.row_factory = sqlite3.Row  # return rows as dicts
    try:
        cur = db.cursor()
        try:
            res = cur.execute(query, args).fetchall()
        finally:
            cur.close()
    except sqlite3.DatabaseError as e:
        raise e
    finally:
        db.close()

    if one:
        if res:
            return res[0]
        else:
            return None
    else:
        return res


def execute_db(statement, args=()):
    db = sqlite3.connect(sketchlink.DB_PATH)
    try:
        cur = db.cursor()
        try:
            cur.execute(statement, args)
            db.commit()
        finally:
            cur.close()
    except sqlite3.DatabaseError as e:
        db.rollback()
        raise e
    finally:
        db.close()