import flask
import sketchlink

from sketchlink.flask import flask_app

@flask_app.route("/")
def serve_index():
    return flask.redirect("/open")

@flask_app.route("/open")
def open_webview():
    return flask.render_template("index.html", sketch_id="", code_id="")

@flask_app.route("/open/<regex('" + sketchlink.SKETCH_ID_RE + "'):sketch_id>")
def open_webview_s(sketch_id):
    return flask.render_template("index.html", sketch_id=sketch_id, code_id="")

@flask_app.route("/link/<regex('" + sketchlink.CODE_ID_RE + "'):code_id>")
def open_webview_c(code_id):
    return flask.render_template("index.html", sketch_id="", code_id=code_id)

@flask_app.route("/open/<regex('" + sketchlink.SKETCH_ID_RE + "'):sketch_id>" + "/link/<regex('" + sketchlink.CODE_ID_RE + "'):code_id>")
def open_webview_sc(sketch_id, code_id):
    return flask.render_template("index.html", sketch_id=sketch_id, code_id=code_id)

@flask_app.route("/<path:static_path>")
def serve_webview(static_path):
    return flask.send_from_directory(sketchlink.WEBVIEW_PATH, static_path)

@flask_app.route("/open/<path:static_path>")
def serve_webview_open(static_path):
    return flask.send_from_directory(sketchlink.WEBVIEW_PATH, static_path)

@flask_app.route("/link/<path:static_path>")
def serve_webview_link(static_path):
    return flask.send_from_directory(sketchlink.WEBVIEW_PATH, static_path)